﻿define([
    'jquery',
    'nico/drop',
    'nico/dispatcher',
    'nico/systeemBoodschappen'
], function ($, Drop, Dispatcher, systeemBoodschappen) {
    'use strict';

    var defaults = function () {
        return {
            tekst: ''
        }
    };

    function AchterkantKaartKnop(options, $element) {
        Drop.call(this, $element, defaults());

        this.data = $.extend(this.data, options);

        this.$tekst = $('<a />')
            .addClass('button lined small green')
            .click(function (e) {
                self.handleClick();
                e.preventDefault();
            })
            .text(this.data.tekst);

        this.$systeemBoodschap = $('<div />');

        var self = this;
        this.$element
            .append(this.$tekst, this.$systeemBoodschap);
    };

    Drop.extend(AchterkantKaartKnop, Drop);

    AchterkantKaartKnop.prototype.dispatcher = new Dispatcher();

    AchterkantKaartKnop.prototype.handleClick = function () {
        if (!this.data.quizMaster)
            return;
        
        if (this.data.quizMaster.allesIngevuld()) {
            var self = this;
            var hasAntwoorden = this.data.quizMaster.hasAntwoorden();
            var batch = [];

            batch.push({
                route: 'increaseTeller',
                data: {
                    tellerId: this.data.variabele.id
                },
                done: function() {
                    self.parent.raiseEvent('backOfCardOpened', { hadAntwoorden: hasAntwoorden });
                }
            });

            if (hasAntwoorden) {
                batch.push({
                    route: 'antwoordenOpslaan',
                    data: {
                        antwoorden: this.data.quizMaster.getAntwoorden()
                    },
                    done: $.noop
                });
            }

            this.dispatcher.postBatch(batch);
        } else {
            var boodschap = systeemBoodschappen.get('NietAlleVerplichteVeldenIngevuld');
            this.$systeemBoodschap.text(boodschap);
            this.getRootDrop().raiseEvent('layoutUpdated');
        }
    };

    AchterkantKaartKnop.prototype.preRender = function () {
        this.applyPosition();
    };

    return AchterkantKaartKnop;
});