﻿define([
    'jquery',
    'nico/drop',
    './achterkantKaartKnop',
    'nico/Designer/propertyEditors',
    'nico/Designer/buttonDesign'
], function ($, Drop, AchterkantKaartKnop, propertyEditors, ButtonDesign) {
    'use strict';

    function AchterkantKaartKnopDesign(options, $element) {
        AchterkantKaartKnop.call(this, options, $element);

        this.buttonDesign = new ButtonDesign(this.data);

        if(this.data.tekstInherited)
            this.$element
                .addClass('inheritedTekst');

        this.initAnchorData(this.data);
        this.addClicksForEdit(this.getPropertyEditors());
    };

    Drop.extend(AchterkantKaartKnopDesign, AchterkantKaartKnop);

    AchterkantKaartKnopDesign.prototype.handleClick = $.noop;

    AchterkantKaartKnopDesign.prototype.getPropertyEditors = function () {
        var self = this;
        return this.buttonDesign.decorateEditors([

            propertyEditors.createText('Knop tekst')
                .withGet(function () {
                    return self.$tekst.text();
                })
                .withSet(function (value) {
                    self.$tekst.text(value);
                })
                .withDataDecorator('tekst')

        ]);
    };

    AchterkantKaartKnopDesign.prototype.addSaveData = function (data) {
        this.buttonDesign.addSaveData(data);
        data.tekst = this.$tekst.html();
    };

    AchterkantKaartKnopDesign.prototype.afterSave = function () {
        this.$element.removeClass('inheritedTekst');
    };

    AchterkantKaartKnopDesign.prototype.createOperationRoute = 'addAchterkantKaartKnop';
    AchterkantKaartKnopDesign.prototype.updateOperationRoute = 'updateAchterkantKaartKnop';

    return AchterkantKaartKnopDesign;
});