﻿define([
    'jquery',
    'nico/drop',
    'nico/url'
], function ($, Drop, url) {
    'use strict';

    var defaults = {
    };

    function Afbeelding(options, $element) {
        Drop.call(this, $element, defaults);
        this.data = $.extend(this.data, options);

        this.renderedPromise = $.Deferred();

        this.$img = $('<img />');
    };

    Drop.extend(Afbeelding, Drop);

    Afbeelding.prototype.promise = function () {
        return this.renderedPromise.promise();
    };
    
    Afbeelding.prototype.preRender = function () {
        this.applyPosition();

        if (this.data.filename) {
            var self = this;
            this.$img = $('<img />')
                .load(function() {
                    self.renderedPromise.resolve();
                })
                .error(function() {
                    self.renderedPromise.resolve();
                });
            this.setImageSrc(url.toUploadUrl(this.data.filename));
        } else {
            this.renderedPromise.resolve();
        }
    };

    Afbeelding.prototype.setImageSrc = function (src) {
        this.$img
            .attr('src', src)
            .appendTo(this.$element);
    };

    Afbeelding.prototype.removeImage = function () {
        this.$img.detach();
    };

    return Afbeelding;
});