﻿define([
    'jquery',
    'nico/drop',
    'nico/boolRewrite',
    './../VraagStelling/vraagStelling'
], function ($, Drop, BoolRewrite, VraagStelling) {
    'use strict';

    var defaults = function() {
        return {
            onLabel: 'on',
            offLabel: 'off',
            noNeedToShowVerplichtEditor: true,
            variabele: {
                type: 'bool'
            },
            boolRewrite: {
                'false': 0,
                'true': 1
            }
        };
    };

    function BinaireSwitch(options, $element) {
        VraagStelling.call(this, $.extend(defaults(), options), $element);

        this.bool = new BoolRewrite(this.data);
    };

    Drop.extend(BinaireSwitch, VraagStelling);

    BinaireSwitch.prototype.getInitialSwitchState = function () {
        var value = this.getInitieelAntwoord();
        return this.bool.getBoolFromValue(value);
    };

    BinaireSwitch.prototype.updateAntwoord = function () {
        var antwoord = this.bool.getValueFromBool(this.$input.is(':checked'));
        this.registreerAntwoord(antwoord);
    };
    
    BinaireSwitch.prototype.clearValue = function () {
        this.$input.attr('checked', false);
    };

    BinaireSwitch.prototype.preRender = function () {
        this.applyPosition();
    };

    BinaireSwitch.prototype.render = function () {
        var id = _.uniqueId('binaireSwitch');

        var self = this;
        this.$input = $('<input type="checkbox" id="' + id + '" />')
            .addClass('onoffswitch-checkbox')
            .prop('checked', self.getInitialSwitchState())
            .change(function () {
                self.updateAntwoord();
            });
        
        this.$onLabel = $('<span />')
            .text(this.data.onLabel);

        this.$offLabel = $('<span />')
            .addClass('onoffswitch-inner')
            .text(this.data.offLabel);

        var $label = $('<label />')
            .attr('for', id)
            .addClass('onoffswitch-label')
            .append($('<span />').addClass('onoffswitch-inner'))
            .append($('<span />').addClass('onoffswitch-switch'));
        $('<div />')
            .addClass('onoffswitch')
            .append(this.$input, $label)
            .appendTo(this.$element);

        this.updateAntwoord();
    };

    return BinaireSwitch;
});