﻿define([
    'jquery',
    'nico/drop',
    './binaireSwitch',
    './../VraagStelling/vraagStellingDesign',
    'nico/Designer/propertyEditors'
], function ($, Drop, BinaireSwitch, VraagStellingDesign, propertyEditors) {
    'use strict';

    function BinaireSwitchDesign(options, $element) {

        BinaireSwitch.call(this, options, $element);

        this.vraagStellingDesign = new VraagStellingDesign();

        if (this.data.tekstInherited)
            this.$element
                .addClass('inheritedTekst');

        this.initAnchorData(this.data);
        this.addClicksForEdit(this.getPropertyEditors());
        
    }

    Drop.extend(BinaireSwitchDesign, BinaireSwitch);

    BinaireSwitchDesign.prototype.addSaveData = function (data) {
        this.vraagStellingDesign.decorateSaveData(data, this.data);
        data.onLabel = this.$onLabel.text();
        data.offLabel = this.$offLabel.text();
    };

    BinaireSwitchDesign.prototype.afterSave = function () {
        this.$element
            .removeClass('inheritedTekst');
    };

    BinaireSwitchDesign.prototype.createOperationRoute = "addBinaireSwitchDrop";
    BinaireSwitchDesign.prototype.updateOperationRoute = "updateBinaireSwitchDrop";

    BinaireSwitchDesign.prototype.getPropertyEditors = function () {
        var self = this;
        return this.vraagStellingDesign.decorateEditors(
            propertyEditors.createCheckBox('Default Waarde'),
            [
                propertyEditors.createBoolNumericRewrite('Numerieke waarde', self)
                    .withGet(function () {
                        return self.data.boolRewrite;
                    })
                    .withSet(function (value) {
                        self.data.boolRewrite = value;
                    })
                    .withDataDecorator('boolRewrite'),

                propertyEditors.createText('On label')
                    .withGet(function() {
                        return self.$onLabel.text();
                    })
                    .withSet(function(value) {
                        self.$onLabel.text(value);
                    })
                    .withDataDecorator('onLabel'),

                propertyEditors.createText('Off label')
                    .withGet(function() {
                        return self.$offLabel.text();
                    })
                    .withSet(function(value) {
                        self.$offLabel.text(value);
                    })
                    .withDataDecorator('offLabel')
            ],
            self.data);
    };

    return BinaireSwitchDesign;
});