﻿define([
    'jquery',
    'nico/drop',
    'nico/dispatcher',
    'nico/cardRuntime'
], function ($, Drop, Dispatcher, CardRuntime) {
    'use strict';

    var defaults = function () {
        return {
            tekst: '',
            card: null,
            kant: 'achterkant'
        };
    };

    function CardKnop(options, $element) {
        Drop.call(this, $element, defaults());

        this.data = $.extend(this.data, options);

        this.$tekst = $('<a />')
            .addClass('button lined small green')
            .click(function() {
                self.handleClick();
            })
            .text(this.data.tekst);

        var self = this;
        this.$element
            .append(this.$tekst);
    };

    Drop.extend(CardKnop, Drop);

    CardKnop.prototype.dispatcher = new Dispatcher();

    CardKnop.prototype.handleClick = function () {
        if (!this.data.quizMaster)
            return;

        var self = this;
        this.dispatcher
            .post('increaseTeller', {
                tellerId: this.data.variabele.id
            })
            .done(function () {
                if (!self.cardRuntime)
                    self.cardRuntime = new CardRuntime(self, self.data.card.id, self.data.kant);
                self.cardRuntime.openCard();
            });
    };

    CardKnop.prototype.preRender = function () {
        this.applyPosition();
    };

    return CardKnop;
});