﻿define([
    'jquery',
    'nico/drop',
    './cardKnop',
    'nico/Designer/propertyEditors',
    'nico/Designer/buttonDesign',
     './CardPropertyEditor'
], function ($, Drop, CardKnop, propertyEditors, ButtonDesign, CardPropertyEditor) {
    'use strict';

    var kanten = [
        {
            label: 'Achterkant',
            key: 'achterkant'
        },
        {
            label: 'Voorkant',
            key: 'voorkant'
        }
    ];

    function CardKnopDesign(options, $element) {
        CardKnop.call(this, options, $element);

        this.buttonDesign = new ButtonDesign(this.data);

        if (this.data.tekstInherited)
            this.$element
                .addClass('inheritedTekst');

        this.initAnchorData(this.data);
    }

    Drop.extend(CardKnopDesign, CardKnop);

    CardKnopDesign.prototype.handleClick = function () { };

    CardKnopDesign.prototype.preRender = function () {
        this.applyPosition();
        this.addClicksForEdit(this.getPropertyEditors());
    };

    CardKnopDesign.prototype.getPropertyEditors = function () {
        var self = this;

        return this.buttonDesign.decorateEditors([

            propertyEditors.createText('Knop tekst')
                .withGet(function() {
                    return self.$tekst.text();
                })
                .withSet(function(value) {
                    self.$tekst.text(value);
                })
                .withDataDecorator('tekst'),
            
            new CardPropertyEditor('Card')
                .withGet(function () {
                        return self.data.card;
                })
                .withSet(function (value) {
                    self.data.card = value;
                }),

            propertyEditors.createRadioButtons('Getoonde kant', kanten)
                .withDropDataPath(this, 'kant')
                .withDataDecorator('kant')
        
        ]);
    };

    CardKnopDesign.prototype.addSaveData = function (data) {
        this.buttonDesign.addSaveData(data);
        data.tekst = this.$tekst.html();
        data.card = this.data.card;
    };

    CardKnopDesign.prototype.afterSave = function () {
        this.$element
            .removeClass('inheritedTekst');
    };

    CardKnopDesign.prototype.createOperationRoute = 'addCardKnop';
    CardKnopDesign.prototype.updateOperationRoute = 'updateCardKnop';

    return CardKnopDesign;
});