﻿define([
    'nico/Designer/PropertyEditors/propertyEditor',
    'underscore',
    './cardEditor'
], function (PropertyEditor, _, CardEditor) {
    'use strict';

    function CardPropertyEditor(label) {
        PropertyEditor.call(this, label);
    }

    PropertyEditor.extend(CardPropertyEditor, PropertyEditor);

    CardPropertyEditor.propertyEditorName = 'CardPropertyEditor';

    CardPropertyEditor.prototype.render = function ($body) {
        var $card = $('<div />')
            .css({
                width: '250px'
            });

        var self = this;
        _.defer(function() {
            self.initCard($card);
        });

        return this.createRow($body, this.label, $card);
    };

    CardPropertyEditor.prototype.initCard = function ($card) {
        this.cardEditor = new CardEditor($card);

        var value = this.getValue();
        if (value)
            this.cardEditor.setCard(value);

        var self = this;
        this.cardEditor.onChanged(function (card) {
            self.setValue(card);
        });
    };

    return CardPropertyEditor;
});