﻿define([
    'jquery',
    'nico/drop',
    './carouselPager',
    'nico/Designer/propertyEditors'
], function ($, Drop, CarouselPager, propertyEditors) {
    'use strict';

    function CarouselPagerDesign(options, $element) {
        CarouselPager.call(this, options, $element);

        if (this.data.tekstInherited)
            this.$element
                .addClass('inheritedTekst');

        this.addClicksForEdit(this.getPropertyEditors());
    };

    Drop.extend(CarouselPagerDesign, CarouselPager);

    CarouselPagerDesign.prototype.recreateCarousel = function () {
        if (this.container.$element.data('owlCarousel') !== undefined)
            this.container.$element.data('owlCarousel').destroy();

        if (this.container.pool.length !== 0) {
            this.container.$element.owlCarousel({
                singleItem: true,
                slideSpeed: 300
            });
        }
    };

    CarouselPagerDesign.prototype.preRender = function () {
        CarouselPager.prototype.preRender.call(this);

        var self = this;
        this.container.addListener('dropAdded', function () {
            self.recreateCarousel();
        });
        this.container.addListener('dropDeleted', function () {
            self.recreateCarousel();
        });
    };

    CarouselPagerDesign.prototype.getPropertyEditors = function () {
        var self = this;

        return [
            
            propertyEditors.createText('Tekst volgende stap')
                .withGet(function () {
                    return self.$volgende.html();
                })
                .withSet(function (value) {
                    self.$volgende.html(value);
                })
                .withDataDecorator('volgende'),

            propertyEditors.createText('Tekst vorige stap')
                .withGet(function () {
                    return self.$vorige.html();
                })
                .withSet(function (value) {
                    self.$vorige.html(value);
                })
                .withDataDecorator('vorige')

        ];
    };

    CarouselPagerDesign.prototype.addSaveData = function (data) {
        data.volgende = this.$volgende.html();
        data.vorige = this.$vorige.html();
    };

    CarouselPagerDesign.prototype.afterSave = function () {
        this.$element
            .removeClass('inheritedTekst');
    };

    CarouselPagerDesign.prototype.createOperationRoute = 'addCarouselPagerDrop';
    CarouselPagerDesign.prototype.updateOperationRoute = 'updateCarouselPagerDrop';

    return CarouselPagerDesign;
});