﻿define([
    'jquery',
    'nico/drop',
    'nico/boolRewrite',
    './../VraagStelling/vraagStelling'
], function ($, Drop, BoolRewrite, VraagStelling) {
    'use strict';

    var defaults = function() {
        return {
            label: 'label',
            noNeedToShowVerplichtEditor: true,
            variabele: {
                type: 'number'
            },
            boolRewrite: {
                'false': 0,
                'true': 1
            },
        };
    };

    function Checkbox(options, $element) {
        VraagStelling.call(this, $.extend(defaults(), options), $element);

        var self = this;

        this.bool = new BoolRewrite(this.data);
        var id = _.uniqueId('checkbox');

        this.$input = $('<input type="checkbox" id="' + id + '" />')
            .prop('checked', self.getInitialCheckboxState())
            .change(function () {
                self.updateAntwoord();
            });

        this.$label = $('<label />')
             .attr('for', id)
             .text(this.data.label);

        this.$element
            .append(this.$input)
            .append(this.$label);

        this.updateAntwoord();
    };

    Drop.extend(Checkbox, VraagStelling);

    Checkbox.prototype.getInitialCheckboxState = function() {
        var value = this.getInitieelAntwoord();
        return this.bool.getBoolFromValue(value);
    };
    
    Checkbox.prototype.getDefaultwaarde = function () {
        if(this.bool) // todo : fixme
            return this.bool.getValueFromBool(this.data.variabele.defaultWaarde);
        return null;
    };

    Checkbox.prototype.updateAntwoord = function () {
        var antwoord = this.bool.getValueFromBool(this.$input.is(':checked'));
        this.registreerAntwoord(antwoord);
    };

    Checkbox.prototype.clearValue = function () {
        this.$input.attr('checked', false);
    };

    Checkbox.prototype.preRender = function () {
        this.applyPosition();
    };

    return Checkbox;
});