﻿define([
    'jquery',
    'nico/drop',
    './Checkbox',
    './../VraagStelling/vraagStellingDesign',
    'nico/Designer/propertyEditors'
], function ($, Drop, Checkbox, VraagStellingDesign, propertyEditors) {
    'use strict';

    function CheckboxDesign(options, $element) {
        Checkbox.call(this, options, $element);

        this.vraagStellingDesign = new VraagStellingDesign();

        if (this.data.tekstInherited)
            this.$element
                .addClass('inheritedTekst');

        this.initAnchorData(this.data);
        this.addClicksForEdit(this.getPropertyEditors());
    }

    Drop.extend(CheckboxDesign, Checkbox);

    CheckboxDesign.prototype.addSaveData = function (data) {
        this.vraagStellingDesign.decorateSaveData(data, this.data);
        data.label = this.$label.text();
        data.conditie = this.data.conditie;
    };

    CheckboxDesign.prototype.afterSave = function () {
        this.$element
            .removeClass('inheritedTekst');
    };

    CheckboxDesign.prototype.createOperationRoute = 'addCheckBoxDrop';
    CheckboxDesign.prototype.updateOperationRoute = 'updateCheckBoxDrop';

    CheckboxDesign.prototype.getPropertyEditors = function () {
        var self = this;
        return this.vraagStellingDesign
            .decorateEditors(
                propertyEditors.createCheckBox('Default Waarde'),
                [
                    propertyEditors.createBoolNumericRewrite('Numerieke waarde', self)
                        .withGet(function() {
                            return self.data.boolRewrite;
                        })
                        .withSet(function(value) {
                            self.data.boolRewrite = value;
                        })
                        .withDataDecorator('boolRewrite'),

                    propertyEditors.createText('Label')
                        .withGet(function() {
                            return self.$label.text();
                        })
                        .withSet(function(value) {
                            self.$label.text(value);
                        })
                        .withDataDecorator('label'),

                    propertyEditors.createTextArea('Conditie')
                        .withGet(function () {
                            return self.data.conditie;
                        })
                        .withSet(function (value) {
                            self.data.conditie = value;
                        })
                        .onlyShowWhen(function () {
                            return self.data.conditional;
                        })
                        .withDataDecorator('conditie')
                ],
                self.data);
    };

    return CheckboxDesign;
});