﻿define([
    'jquery',
    'underscore',
    'nico/drop',
    'nico/dispatcher'
], function ($, _, Drop, Dispatcher) {
    'use strict';

    var defaults = function () {
        return {
            tekst: ''
        }
    };

    function CompareBalk(options, $element) {
        Drop.call(this, $element, defaults());

        this.data = $.extend(this.data, options);

        this.$balk = $('<div class="comparebalk"/>');

        this.$labelLinks = $('<p />')
            .addClass('comparebalk-label-links')
            .text(this.data.labelLinks)
            .appendTo(this.$balk);

        this.$labelRechts = $('<p />')
            .addClass('comparebalk-label-rechts')
            .text(this.data.labelRechts)
            .appendTo(this.$balk);

        this.$tekstOutro = $('<p />')
            .html(this.data.tekstOutro);

        this.$element.append(this.$balk, this.$tekstOutro);
    };

    Drop.extend(CompareBalk, Drop);

    CompareBalk.prototype.allRequiredValuesAreAvailable = function () {
        if (this.data.calculatedValueLinks == undefined)
            return false;
        if (this.data.calculatedValueRechts == undefined)
            return false;
        return true;
    };

    CompareBalk.prototype.appendValues = function () {
        var min = this.data.calculatedValueLinks;
        var max = this.data.calculatedValueRechts;
        var diff = max - min;
        var meanLeft = 0;
        if (this.data.calculatedValueMean == undefined) {
            $('<div />')
                .css({ height: '39px', position: 'relative' })
                .appendTo(this.$balk);
        } else {
            meanLeft = ((this.data.calculatedValueMean - min) / diff) * 100;
            var $mean =
                $('<div />').css({ left: meanLeft + '%', position: 'relative' })
                .appendTo(this.$balk);
            $('<div />')
                .addClass('comparebalk-value')
                .append($('<span class="icon"/>')
                    .css({ left: '-9px', position: 'absolute', top: '-22px', fontSize: '120%' })
                    .addClass(this.data.iconMean))
                .appendTo($mean);
        }
        if (!(this.data.calculatedValueUser == undefined)) {
            var userLeft = ((this.data.calculatedValueUser - min) / diff) * 100;
            var $user =
                $('<div />').css({ left: userLeft + '%', position: 'relative' })
                .appendTo(this.$balk);
            $('<div />')
                .addClass('comparebalk-value')
                .css({ position: 'relative', top: '-10px' })
                .append($('<span class="icon"/>')
                    .css({ left: '-9px', position: 'absolute', top: '-22px', fontSize: '120%' })
                    .addClass(this.data.iconUser))
                .appendTo($user);
        }
    };

    CompareBalk.prototype.dispatcher = new Dispatcher();

    CompareBalk.prototype.preRender = function () {
        this.applyPosition();
        var self = this;
        _.defer(function() {
            if (self.allRequiredValuesAreAvailable()) {
                self.appendValues();
            }
        });
    };

    return CompareBalk;
});