﻿define([
    'jquery',
    'nico/drop',
    './compareBalk',
    'nico/Designer/propertyEditors'
], function ($, Drop, CompareBalk, propertyEditors) {
    'use strict';

    function CompareBalkDesign(options, $element) {
        CompareBalk.call(this, options, $element);
        //if (this.data.tekstInherited)
        //    this.$element
        //        .addClass('inheritedTekst');
        this.initAnchorData(this.data);
        this.addClicksForEdit(this.getPropertyEditors());
    };

    Drop.extend(CompareBalkDesign, CompareBalk);

    CompareBalkDesign.prototype.addSaveData = function (data) {
        data.labelLinks = this.$labelLinks.text();
        data.labelRechts = this.$labelRechts.text();
        data.valueLinks = this.data.valueLinks;
        data.valueRechts = this.data.valueRechts;
        data.valueUser = this.data.valueUser;
        data.iconUser = this.data.iconUser;
        data.valueMean = this.data.valueMean;
        data.iconMean = this.data.iconMean;
        data.tekstOutro = this.$tekstOutro.html();
    };

    CompareBalkDesign.prototype.getPropertyEditors = function () {
        var self = this;
        return [

            propertyEditors.createText('Label links')
                .withGet(function () {
                    return self.$labelLinks.text();
                })
                .withSet(function (value) {
                    self.$labelLinks.text(value);
                })
                .withDataDecorator('labelLinks'),

            propertyEditors.createText('Label rechts')
                .withGet(function () {
                    return self.$labelRechts.text();
                })
                .withSet(function (value) {
                    self.$labelRechts.text(value);
                })
                .withDataDecorator('labelRechts'),

            propertyEditors.createText('Value links (start balk)')
                .withGet(function () {
                    return self.data.valueLinks;
                })
                .withSet(function (value) {
                    self.data.valueLinks = value;
                })
                .withDataDecorator('valueLinks'),

            propertyEditors.createText('Value rechts (einde balk)')
                    .withGet(function () {
                        return self.data.valueRechts;
                    })
                    .withSet(function (value) {
                        self.data.valueRechts = value;
                })
                .withDataDecorator('valueRechts'),

            propertyEditors.createText('Value user')
                .withGet(function () {
                    return self.data.valueUser;
                })
                .withSet(function (value) {
                    self.data.valueUser = value;
                })
                .withDataDecorator('valueUser'),

            propertyEditors.createIcon('Icon user')
                .withGet(function () {
                    return self.data.iconUser;
                })
                .withSet(function (value) {
                    self.data.iconUser = value;
                })
                .withDataDecorator('iconUser'),

            propertyEditors.createText('Value mean')
                    .withGet(function () {
                        return self.data.valueMean;
                    })
                    .withSet(function (value) {
                        self.data.valueMean = value;
                    })
                .withDataDecorator('valueMean'),

            propertyEditors.createIcon('Icon mean')
                .withGet(function () {
                    return self.data.iconMean;
                })
                .withSet(function (value) {
                    self.data.iconMean = value;
                })
                .withDataDecorator('iconMean'),

            propertyEditors.createTextArea('Tekst (outro)')
                .withGet(function () {
                    return self.$tekstOutro.text();
                })
                .withSet(function (value) {
                    self.$tekstOutro.text(value);
                })
                .withDataDecorator('tekstOutro')

        ];
    };

    CompareBalkDesign.prototype.afterSave = function () {
        //this.$element.removeClass('inheritedTekst');
    };

    CompareBalkDesign.prototype.createOperationRoute = 'addCompareBalk';
    CompareBalkDesign.prototype.updateOperationRoute = 'updateCompareBalk';

    return CompareBalkDesign;
});