﻿define([
    'jquery',
    'nico/drop',
    'nico/eventing',
    'underscore'
], function ($, Drop, eventing, _) {
    'use strict';

    var defaults = {
        keuzes: [{ label: 'label', waarde: 'waarde' }],
        tags: [],
        value: null,
        variabele: {
            naam: null,
            type: null,
            defaultWaarde: null
        },
        verplicht: false
    };

    function DropDown(options, $element) {
        Drop.call(this, $element, defaults);
        this.data = $.extend(this.data, options);
        var self = this;
        eventing.informListeners('nieuweVraag', this.data.variabele.naam, this.data.verplicht);

        this.$dropDown = $('<select />')
            .css({
                height: '100%',
                width: '100%'
            })
            .change(function() {
                eventing.informListeners('antwoordAangepast', {
                    'variabele': self.data.variabele.naam,
                    'waarde': self.$dropDown.val()
                });
            })
            .appendTo(this.$element);

        return this;
    };

    Drop.extend(DropDown, Drop);

    DropDown.prototype.clearValue = function () {
        this.$dropDown.val(null);
    };

    DropDown.prototype.preRender = function () {
        this.renderOptions();
        this.applyPosition();
    };

    DropDown.prototype.renderOptions = function () {
        var $options = [];
        $options.push($('<option>', { text: '...', value: null }));
        _.each(this.data.keuzes, function(keuze) {
            $options.push($('<option>', { text: keuze.label, value: keuze.waarde }));
        });

        this.$dropDown
            .empty()
            .append($options);
    };

    return DropDown;
});
