﻿define([
    'jquery',
    'nico/drop'
], function ($, Drop) {
    'use strict';

    var defaults = function () {
        return {
            icon: ''
        };
    };

    function Icon(options, $element) {
        Drop.call(this, $element, defaults());

        this.data = $.extend(this.data, options);

        this.$element
            .addClass('icons');
        this.setIcon(this.data.icon);

        return this;
    };

    Drop.extend(Icon, Drop);

    Icon.prototype.preRender = function () {
        this.applyPosition();
    };

    Icon.prototype.setIcon = function (iconClass) {
        this.$element
            .empty()
            .append($('<span />').addClass('icon ' + iconClass));
    };

    return Icon;
});