﻿define([
    'jquery',
    'nico/drop',
    './icon',
    'nico/Designer/propertyEditors'
], function ($, Drop, Icon, propertyEditors) {
    'use strict';

    function IconDesign(options, $element) {
        Icon.call(this, options, $element);

        this.initAnchorData(this.data);
        this.addClicksForEdit(this.getPropertyEditors());
    };

    Drop.extend(IconDesign, Icon);

    IconDesign.prototype.getPropertyEditors = function () {
        var self = this;

        return [

            propertyEditors.createIcon('Icon')
                .withGet(function () {
                    return self.data.icon;
                })
                .withSet(function (value) {
                    self.setIcon(value);
                    self.data.icon = value;
                })
                .withDataDecorator('icon')

        ];
    };

    return IconDesign;
});