﻿define([
    'jquery',
    'nico/drop'
], function ($, Drop) {
    'use strict';

    var defaults = function () {
        return {
            icon: '',
            aantalIcons: 5
        };
    };

    function Icons(options, $element) {
        Drop.call(this, $element, defaults());

        this.data = $.extend(this.data, options);

        this.$element
            .addClass('icons');
    };

    Drop.extend(Icons, Drop);

    Icons.prototype.preRender = function () {
        this.renderIcons();
        this.applyPosition();
    };

    Icons.prototype.renderIcons = function () {
        this.$element.empty();

        if (this.data.aantalIcons) {
            var aantalIngekleurd = this.data.calculatedAantalIngekleurd || 0;

            for (var i = 0; i < this.data.aantalIcons; i++) {
                var $icon = $('<span />').addClass('icon ' + this.data.icon);
                if (i + 1 <= aantalIngekleurd)
                    $icon.addClass('color-text');
                this.$element.append($icon);
            }
        }
    };

    return Icons;
});