﻿define([
    'jquery',
    'nico/drop',
    './icons',
    'nico/Designer/propertyEditors'
], function ($, Drop, Icons, propertyEditors) {
    'use strict';

    function IconsDesign(options, $element) {
        Icons.call(this, options, $element);
        
        this.calculateAantalIngekleurd();
        this.initAnchorData(this.data);
        this.addClicksForEdit(this.getPropertyEditors());
    };

    Drop.extend(IconsDesign, Icons);

    IconsDesign.prototype.calculateAantalIngekleurd = function () {
        this.data.calculatedAantalIngekleurd = this.data.aantalIcons / 2;
    };

    IconsDesign.prototype.addSaveData = function (data) {
        data.aantalIngekleurd = this.data.aantalIngekleurd;
    };

    IconsDesign.prototype.getPropertyEditors = function () {
        var self = this;

        return [

            propertyEditors.createIcon('Icon')
                .withGet(function () {
                    return self.data.icon;
                })
                .withSet(function (value) {
                    self.data.icon = value;
                    self.renderIcons();
                })
                .withDataDecorator('icon'),

            propertyEditors.createNumeric('Aantal icons')
                .withGet(function () {
                    return self.data.aantalIcons;
                })
                .withSet(function (value) {
                    self.data.aantalIcons = value;
                    self.calculateAantalIngekleurd();
                    self.renderIcons();
                })
                .withDataDecorator('aantalIcons'),

            propertyEditors.createTextArea('Aantal icons ingekleurd')
                .withGet(function () {
                    return self.data.aantalIngekleurd;
                })
                .withSet(function (value) {
                    self.data.aantalIngekleurd = value;
                })
                .withDataDecorator('aantalIngekleurd')

        ];
    };

    IconsDesign.prototype.createOperationRoute = 'addIconsDrop';
    IconsDesign.prototype.updateOperationRoute = 'updateIconsDrop';

    return IconsDesign;
});