﻿define([
    'jquery',
    'nico/drop',
    'nico/url',
    'nico/dispatcher'
], function ($, Drop, url, Dispatcher) {
    'use strict';

    var defaults = function () {
        return {
            tekst: '',
            url: ''
        };
    };

    function InterneLinkKnop(options, $element) {
        Drop.call(this, $element, defaults());

        this.data = $.extend(this.data, options);

        this.$tekst = $('<a />')
            .addClass('button lined small green')
            .click(function (e) {
                self.handleClick();
                e.preventDefault();
            })
            .text(this.data.tekst);

        var self = this;
        this.$element
            .append(this.$tekst);
    };

    Drop.extend(InterneLinkKnop, Drop);

    InterneLinkKnop.prototype.dispatcher = new Dispatcher();

    InterneLinkKnop.prototype.handleClick = function () {
        if (!this.data.quizMaster)
            return;

        if (this.data.quizMaster.allesIngevuld()) {
            var self = this;
            var hasAntwoorden = this.data.quizMaster.hasAntwoorden();
            var batch = [];

            batch.push({
                route: 'increaseTeller',
                data: {
                    tellerId: this.data.variabele.id
                },
                done: function() {
                    url.redirect(self.data.url);
                }
            });

            if (hasAntwoorden) {
                batch.push({
                    route: 'antwoordenOpslaan',
                    data: {
                        antwoorden: this.data.quizMaster.getAntwoorden()
                    },
                    done: $.noop
                });
            }

            this.dispatcher.postBatch(batch);
        } else {
            url.redirect(this.data.url);
        }
    };

    InterneLinkKnop.prototype.preRender = function () {
        this.applyPosition();
    };

    return InterneLinkKnop;
});