﻿define([
    'jquery',
    'nico/drop',
    'nico/dispatcher',
    './interneLinkKnop',
    'nico/Designer/propertyEditors',
    'nico/Designer/buttonDesign'
], function ($, Drop, Dispatcher, InterneLinkKnop, propertyEditors, ButtonDesign) {
    'use strict';

    function InterneLinkKnopDesign(options, $element) {
        InterneLinkKnop.call(this, options, $element);

        this.buttonDesign = new ButtonDesign(this.data);

        if(this.data.tekstInherited)
            this.$element
                .addClass('inheritedTekst');

        this.initAnchorData(this.data);

        var self = this;
        this.dispatcher
            .post('getPossibleLinks')
            .done(function (result) {
                self.data.possibleLinks = result.links;
                self.addClicksForEdit(self.getPropertyEditors());
            });
    };

    Drop.extend(InterneLinkKnopDesign, InterneLinkKnop);

    InterneLinkKnopDesign.prototype.dispatcher = new Dispatcher();

    InterneLinkKnopDesign.prototype.handleClick = $.noop;

    InterneLinkKnopDesign.prototype.getPropertyEditors = function () {
        var self = this;
        return this.buttonDesign.decorateEditors([

            propertyEditors.createText('Knop tekst')
                .withGet(function () {
                    return self.$tekst.text();
                })
                .withSet(function (value) {
                    self.$tekst.text(value);
                })
                .withDataDecorator('tekst'),

            propertyEditors.createSelect('Link', self.data.possibleLinks)
                .withGet(function () {
                    return self.data.url;
                })
                .withSet(function (value) {
                    self.data.url = value;
                })
                .withDataDecorator('url')

        ]);
    };

    InterneLinkKnopDesign.prototype.addSaveData = function (data) {
        this.buttonDesign.addSaveData(data);
        data.tekst = this.$tekst.html();
    };

    InterneLinkKnopDesign.prototype.afterSave = function () {
        this.$element.removeClass('inheritedTekst');
    };

    InterneLinkKnopDesign.prototype.createOperationRoute = 'addInterneLinkKnop';
    InterneLinkKnopDesign.prototype.updateOperationRoute = 'updateInterneLinkKnop';

    return InterneLinkKnopDesign;
});