﻿define([
    'jquery',
    'nico/drop',
    './../VraagStelling/vraagStelling'
], function ($, Drop, VraagStelling) {
    'use strict';

    var defaults = function() {
        return {
            fixedVariabeleType: true,
            variabele: {
                type: 'string'
            }
        };
    };

    function Invulveld(options, $element) {
        VraagStelling.call(this, $.extend(defaults(), options), $element);

        var self = this;
        this.$textarea = $('<textarea />')
            .val(self.getInitieelAntwoord())
            .bind('input propertychange', function () {
                self.registreerAntwoord(this.value);
            });

        this.$element
            .append(this.$textarea);

        return this;
    };

    Drop.extend(Invulveld, VraagStelling);

    Invulveld.prototype.clearValue = function () {
        this.$textarea.val(null);
    };

    Invulveld.prototype.preRender = function () {
        this.applyPosition();
    };

    return Invulveld;
});