﻿define([
    'jquery',
    'nico/drop',
    './../VraagStelling/vraagStelling',
    'underscore'
], function ($, Drop, VraagStelling, _) {
    'use strict';

    var defaults = function() {
        return {
            keuzes: [{ label: 'label', waarde: 'waarde' }],
            variabele: {
                type: 'number'
            }
        };
    };

    function Keuzelijst(options, $element) {
        VraagStelling.call(this, $.extend(defaults(), options), $element);
    };

    Drop.extend(Keuzelijst, VraagStelling);

    Keuzelijst.prototype.clearValue = function () {
        this.data.value = null;
        this.$element.find('input').attr('checked', false);
    };

    Keuzelijst.prototype.renderRadioButtons = function () {
        var self = this;
        var waarde = self.getInitieelAntwoord();
        var $items = _.map(this.data.keuzes, function (keuze) {
            var id = _.uniqueId('radioButton');

            var $item = $('<div />');

            $('<input type="radio" id="' + id + '" />')
                .attr('name', self.data.variabele.naam)
                .attr('value', keuze.waarde)
                .prop('checked', keuze.waarde == waarde)
                .change(function () {
                    if ($(this).is(":checked"))
                        self.registreerAntwoord(keuze.waarde);
                })
                .appendTo($item);

            $('<label />')
                .attr('for', id)
                .text(keuze.label)
                .appendTo($item);

            return $item;
        });

        this.$element
            .empty()
            .append($items);
    }

    Keuzelijst.prototype.preRender = function () {
        this.renderRadioButtons();
        this.applyPosition();
    };

    return Keuzelijst;
});