﻿define([
    'jquery',
    'nico/drop',
    './keuzelijst',
    './../VraagStelling/vraagStellingDesign',
    'nico/Designer/propertyEditors'
], function ($, Drop, Keuzelijst, VraagStellingDesign, propertyEditors) {
    'use strict';

    function KeuzelijstDesign(options, $element) {
        Keuzelijst.call(this, options, $element);

        this.vraagStellingDesign = new VraagStellingDesign();

        if (this.data.tekstInherited)
            this.$element
                .addClass('inheritedTekst');

        this.initAnchorData(this.data);
        this.addClicksForEdit(this.getPropertyEditors());
    }

    Drop.extend(KeuzelijstDesign, Keuzelijst);

    KeuzelijstDesign.prototype.addSaveData = function (data) {
        this.vraagStellingDesign.decorateSaveData(data, this.data);
        data.keuzes = this.data.keuzes;
    };

    KeuzelijstDesign.prototype.afterSave = function (result) {
        this.$element
            .removeClass('inheritedTekst');
        this.data.keuzes = result.keuzes;
    };

    KeuzelijstDesign.prototype.createOperationRoute = "addKeuzelijstDrop";
    KeuzelijstDesign.prototype.updateOperationRoute = "updateKeuzelijstDrop";

    KeuzelijstDesign.prototype.getPropertyEditors = function () {
        var self = this;
        return this.vraagStellingDesign.decorateEditors(
            propertyEditors.createText('Default Waarde'),
            [
                propertyEditors
                .createKeyValueList(
                    'Keuze mogelijkheden',
                    function() {
                        return { label: 'label', waarde: 'waarde' };
                    },
                    function() {
                        self.renderRadioButtons();
                    })
                .withKeyProperty('label')
                .withValueProperty('waarde')
                .withGet(function() {
                    return self.data.keuzes;
                })
                .withSet(function(value) {
                    self.data.keuzes = value;
                    self.renderRadioButtons();
                })
                .withDataDecorator('keuzes')
            ],
            self.data);
    };

    return KeuzelijstDesign;
});