﻿define([
    'jquery',
    'nico/drop',
    './../VraagStelling/vraagStelling',
    'underscore',
    'nico/url'
], function ($, Drop, VraagStelling, _, url) {
    'use strict';

    var defaults = function() {
        return {
            keuzes: [{ label: 'label', waarde: 'waarde' }],
            variabele: {
                type: 'number'
            }
        };
    };

    function KeuzelijstMetAfbeeldingen(options, $element) {
        VraagStelling.call(this, $.extend(defaults(), options), $element);

        _.each(this.data.keuzes, function (keuze) {
            if (keuze.afbeelding)
                keuze.url = url.toUploadUrl(keuze.afbeelding);
        });
    };

    Drop.extend(KeuzelijstMetAfbeeldingen, VraagStelling);

    KeuzelijstMetAfbeeldingen.prototype.clearValue = function () {
        this.$element
            .find('input')
            .attr('checked', false);
    };

    KeuzelijstMetAfbeeldingen.prototype.renderOptions = function() {
        var self = this;
        var waarde = self.getInitieelAntwoord();
        var $items = _.map(this.data.keuzes, function (keuze) {
            var id = _.uniqueId('radioButton');

            var $figcaption = $('<figcaption />');

            if (keuze.url) {
                $('<label />')
                    .attr('for', id)
                    .append($('<img />').attr('src', keuze.url))
                    .appendTo($figcaption);
            }

            $('<input type="radio" id="' + id + '" />')
                .attr('name', self.data.variabele.naam)
                .attr('value', keuze.waarde)
                .prop('checked', keuze.waarde === waarde)
                .change(function () {
                    if ($(this).is(":checked"))
                        self.registreerAntwoord(keuze.waarde);
                })
                .appendTo($figcaption);

            if (keuze.label) {
                $('<label />')
                    .attr('for', id)
                    .text(keuze.label)
                    .appendTo($figcaption);
            }

            return $('<li />')
                .append($('<figure />').append($figcaption));
        });

        this.$element
            .empty()
            .append($('<ul />').append($items));
    };

    KeuzelijstMetAfbeeldingen.prototype.preRender = function () {
        this.renderOptions();
        this.applyPosition();
    };

    return KeuzelijstMetAfbeeldingen;
});