﻿define([
    'jquery',
    'nico/drop',
    './../VraagStelling/vraagStellingDesign',
    'nico/Designer/propertyEditors',
    './keuzelijstMetAfbeeldingen',
    './keuzelijstMetAfbeeldingenPropertyEditor',
    'nico/url'
], function ($, Drop, VraagStellingDesign, propertyEditors, KeuzelijstMetAfbeeldingen, KeuzelijstMetAfbeeldingenPropertyEditor, url) {
    'use strict';

    function KeuzelijstMetAfbeeldingenDesign(options, $element) {
        KeuzelijstMetAfbeeldingen.call(this, options, $element);

        this.vraagStellingDesign = new VraagStellingDesign();

        if (this.data.tekstInherited)
            this.$element
                .addClass('inheritedTekst');

        this.initAnchorData(this.data);
        this.addClicksForEdit(this.getPropertyEditors());
    }

    Drop.extend(KeuzelijstMetAfbeeldingenDesign, KeuzelijstMetAfbeeldingen);

    KeuzelijstMetAfbeeldingenDesign.prototype.addSaveData = function (data) {
        this.vraagStellingDesign.decorateSaveData(data, this.data);
        data.keuzes = this.data.keuzes;
    };

    KeuzelijstMetAfbeeldingenDesign.prototype.afterSave = function (result) {
        this.$element
            .removeClass('inheritedTekst');

        this.data.keuzes = result.keuzes;
        _.each(this.data.keuzes, function (keuze) {
            if (keuze.afbeelding)
                keuze.url = url.toUploadUrl(keuze.afbeelding);
        });

        this.renderOptions();
    };

    KeuzelijstMetAfbeeldingenDesign.prototype.createOperationRoute = 'addKeuzelijstDrop';
    KeuzelijstMetAfbeeldingenDesign.prototype.updateOperationRoute = 'updateKeuzelijstDrop';
    KeuzelijstMetAfbeeldingenDesign.prototype.deleteOperationRoute = 'deleteKeuzelijstDrop';

    KeuzelijstMetAfbeeldingenDesign.prototype.getPropertyEditors = function () {
        var self = this;

        return this.vraagStellingDesign.decorateEditors(
            propertyEditors.createText('Default Waarde'),
            [
                new KeuzelijstMetAfbeeldingenPropertyEditor(this, 'Keuze mogelijkheden')
                .withGet(function() {
                    return self.data.keuzes;
                })
                .withSet(function(value) {
                    self.data.keuzes = value;

                    _.each(self.data.keuzes, function(keuze) {
                        if (keuze.afbeelding)
                            keuze.url = url.toUploadUrl(keuze.afbeelding);
                    });

                    self.renderOptions();
                })
                .withDataDecorator('keuzes')
            ],
            self.data);
    };

    return KeuzelijstMetAfbeeldingenDesign;
});