﻿define([
    'jquery',
    'nico/drop',
    './numeriekeInput',
    './../Vraagstelling/vraagStellingDesign',
    'nico/Designer/propertyEditors'
], function ($, Drop, NumeriekeInput, VraagStellingDesign, propertyEditors) {
    'use strict';

    function NumeriekeInputDesign(options, $element) {
        NumeriekeInput.call(this, options, $element);

        this.vraagStellingDesign = new VraagStellingDesign();

        this.initAnchorData(this.data);
        this.addClicksForEdit(this.getPropertyEditors());
    }

    Drop.extend(NumeriekeInputDesign, NumeriekeInput);

    NumeriekeInputDesign.prototype.addSaveData = function (data) {
        this.vraagStellingDesign.decorateSaveData(data, this.data);
    };

    NumeriekeInputDesign.prototype.getPropertyEditors = function () {
        var self = this;
        return this.vraagStellingDesign.decorateEditors(
            propertyEditors.createNumeric('Default Waarde'),
            [
                propertyEditors
                    .createNumeric('Minimum')
                    .withGet(function() {
                        return self.data.rangeStart;
                    })
                    .withSet(function(value) {
                        self.data.rangeStart = value;
                    })
                    .withDataDecorator('rangeStart'),
                propertyEditors
                    .createNumeric('Maximum')
                    .withGet(function() {
                        return self.data.rangeEnd;
                    })
                    .withSet(function(value) {
                        self.data.rangeEnd = value;
                    })
                    .withDataDecorator('rangeEnd'),
                propertyEditors
                    .createNumeric('Stapwaarde')
                    .withGet(function() {
                        return self.data.stapWaarde;
                    })
                    .withSet(function(value) {
                        self.data.stapWaarde = value;
                    })
                    .withDataDecorator('stapWaarde'),
                propertyEditors
                    .createNumeric('Startwaarde')
                    .withGet(function () {
                        return self.data.startWaarde;
                    })
                    .withSet(function (value) {
                        self.data.startWaarde = value;
                    })
                    .withDataDecorator('startWaarde'),
                propertyEditors
                    .createCheckBox('Afronden naar dichtsbijzijnde stap')
                    .withGet(function () {
                        return self.data.roundToNearestStap;
                    })
                    .withSet(function (value) {
                        self.data.roundToNearestStap = value;
                    })
                    .withDataDecorator('roundToNearestStap'),
                propertyEditors
                    .createText('Eenheid label')
                    .withGet(function() {
                        return self.data.eenheid;
                    })
                    .withSet(function(value) {
                        self.data.eenheid = value;
                        self.setEenheid(value);
                    })
                .withDataDecorator('eenheid')
            ],
            self.data);
    };

    return NumeriekeInputDesign;
});