﻿define([
    'jquery',
    'nico/drop',
    'nico/dispatcher',
    'nico/systeemBoodschappen'
], function ($, Drop, Dispatcher, systeemBoodschappen) {
    'use strict';

    var defaults = function () {
        return {
            buttonType: 'tekst',
            tekst: ''
        }
    };

    function OpslaanKnop(options, $element) {
        Drop.call(this, $element, defaults());

        this.data = $.extend(this.data, options);

        var self = this;

        if (this.data.buttonType === 'tekst') {
            this.$tekst = $('<a />')
                .addClass('button small green')
                .click(function (e) {
                    self.handleClick();
                    e.preventDefault();
                })
                .text(this.data.tekst)
                .appendTo(this.$element);
        }

        if (this.data.buttonType === 'icon') {
            this.$icon = $('<div />')
                .addClass('icon-knop')
                .click(function (e) {
                    self.handleClick();
                    e.preventDefault();
                })
                .appendTo(this.$element);
            this.setIcon(this.data.icon);
        }

        this.$systeemBoodschap = $('<div />')
            .appendTo(this.$element);
    };

    Drop.extend(OpslaanKnop, Drop);

    OpslaanKnop.prototype.dispatcher = new Dispatcher();

    OpslaanKnop.prototype.handleClick = function () {
        if (!this.data.quizMaster)
            return;

        if (this.data.quizMaster.allesIngevuld()) {
            var batch = [];

            var self = this;
            batch.push({
                route: 'increaseTeller',
                data: {
                    tellerId: this.data.variabele.id
                },
                done: function () {
                    if (self.data.hardRefresh)
                        window.location.reload();
                    else
                        self.parent.raiseEvent('antwoordenOpgeslagen', { hadAntwoorden: true });
                }
            });

            batch.push({
                route: 'antwoordenOpslaan',
                data: {
                    antwoorden: this.data.quizMaster.getAntwoorden()
                },
                done: $.noop
            });

            this.dispatcher.postBatch(batch);
        } else {
            var boodschap = systeemBoodschappen.get('NietAlleVerplichteVeldenIngevuld');
            this.$systeemBoodschap.text(boodschap);
            this.getRootDrop().raiseEvent('layoutUpdated');
        }
    };

    OpslaanKnop.prototype.preRender = function () {
        this.applyPosition();
    };

    OpslaanKnop.prototype.setIcon = function (iconClass) {
        this.$icon
            .empty()
            .append($('<span />').addClass('icon ' + iconClass));
    };

    return OpslaanKnop;
});