﻿define([
    'jquery',
    'underscore',
    'nico/Designer/editorsOverlay',
    'nico/Designer/PropertyEditors/propertyEditor'
], function ($, _, editorsOverlay, PropertyEditor) {
    'use strict';

    function PopupDesigner(knop, $popupContent) {
        PropertyEditor.call(this, "Bewerk popup");
        this.knop = knop;
        this.$popupContent = $popupContent;

        this.withGet(function () { return null; });
        this.withSet(function (value) {  });
    }

    PropertyEditor.extend(PopupDesigner, PropertyEditor);

    PopupDesigner.propertyEditorName = 'PopupDesigner';

    PopupDesigner.prototype.render = function ($body) {
        if (!this.knop.id)
            return this.createRow($body, this.label, $('<div>Bewaar knop eerst.</div>'));

        var self = this;
        this.$input =
            $('<button/>')
                .text('Open')
                .addClass('button small green')
                .click(function () {
                    editorsOverlay.forceUnlock();
                    self.knop.openPopup();
                });

        $('#savePopup').click(function () {
            editorsOverlay.forceUnlock();
            $('#popupDesigner .content').children().detach();
            $('#popupDesigner').hide();
        });

        return this.createRow($body, this.label, this.$input);
    };

    return PopupDesigner;
});