﻿define([
    'jquery',
    'nico/drop',
    'nico/modalWindow',
    'widgets/Runtime/widgetListLayoutRuntime',
    'nico/quizMaster'
], function ($, Drop, modalWindow, WidgetListLayoutRuntime, QuizMaster) {
    'use strict';

    var defaults = function () {
        return {
            tekst: ''
        }
    };

    var $body = $('body');

    var template = _.template($('#popup-template').html());

    function PopupKnop(options, $element) {
        Drop.call(this, $element, defaults());
        this.data = $.extend(this.data, options);

        this.$popupContent = $('<div />');
        this.popup = modalWindow.create($(template()).appendTo($body));
        this.popup.$window
            .find('.close-window')
            .click(function () {
                self.popup.close();
            });

        this.$tekst = $('<a />')
            .addClass('button lined small green')
            .click(function () {
                self.openPopup();
            })
            .text(this.data.tekst);
        var self = this;
        this.$element
            .append(this.$tekst);
    };

    Drop.extend(PopupKnop, Drop);

    PopupKnop.prototype.openPopup = function () {
        if (!this.data.quizMaster)
            return;

        var self = this;
        if (!this.widgetLayout) {
            this.widgetLayout = new WidgetListLayoutRuntime(this.data.drops, this.$popupContent, new QuizMaster());
            this.widgetLayout.render();

            this.widgetLayout.promise().done(function () {
                self.popup
                    .setContent(self.$popupContent)
                    .show()
                    .promise()
                    .done(function () {
                        self.$popupContent.detach();
                    });
            });
        } else {
            this.popup
                .setContent(this.$popupContent)
                .show()
                .promise()
                .done(function () {
                    self.$popupContent.detach();
                });
        }
    };

    return PopupKnop;
});