﻿define([
    'jquery',
    'nico/drop',
    'nico/dispatcher'
], function ($, Drop, Dispatcher) {
    'use strict';

    var defaults = function () {
        return {
            tekst: ''
        }
    };

    function ShareOnFacebook(options, $element) {
        Drop.call(this, $element, defaults());

        var self = this;

        this.data = $.extend(this.data, options);

        this.$twitter = $('<a />')
            .addClass('button small facebook')
            .append($('<span />').addClass('icon icon-facebook'))
            .append($('<span />').text('  FACEBOOK'))
            .click(function (e) {
                self.handleFacebook();
                e.preventDefault();
            });


        this.$element
            .append(this.$tekst, this.$twitter);
    };

    Drop.extend(ShareOnFacebook, Drop);

    ShareOnFacebook.prototype.dispatcher = new Dispatcher();

    ShareOnFacebook.prototype.handleFacebook = function () {
        if (window.plugins && window.plugins.socialsharing) {
            window.plugins.socialsharing.shareViaFacebook(this.data.tekst);
        } else {
            var winHeight = screen.height;
            var winWidth = screen.width;
            var width = 550;
            var height = 420;
            var left = Math.round((winWidth / 2) - (width / 2));
            var top = 0;

            if (winHeight > height) {
                top = Math.round((winHeight / 2) - (height / 2));
            }
            var url = "https://www.facebook.com/dialog/feed?app_id=145634995501895&redirect_uri=https://developers.facebook.com/tools/explorer&display=popup&link=http://stopsmokingcoach.eu/web/&description=" + this.data.tekst;
            window.open(
                url,
                '_blank',
                'width=' + width + ',height=' + height + ',top=' + top + ',left=' + left);
        }
        return false;
    };

    ShareOnFacebook.prototype.preRender = function () {
        this.applyPosition();
    };

    return ShareOnFacebook;
});