﻿define([
    'jquery',
    'nico/drop',
    './shareOnFacebook',
    'nico/Designer/propertyEditors'
], function ($, Drop, ShareOnFacebook, propertyEditors) {
    'use strict';

    function ShareOnFacebookDesign(options, $element) {
        ShareOnFacebook.call(this, options, $element);
        if (this.data.tekstInherited)
            this.$element
                .addClass('inheritedTekst');
        this.initAnchorData(this.data);
        this.addClicksForEdit(this.getPropertyEditors());
    };

    Drop.extend(ShareOnFacebookDesign, ShareOnFacebook);

    ShareOnFacebookDesign.prototype.handleFacebook = $.noop;
    ShareOnFacebookDesign.prototype.handleFacebook = $.noop;

    ShareOnFacebookDesign.prototype.addSaveData = function (data) {
        data.tekst = this.data.tekst;
    };

    ShareOnFacebookDesign.prototype.getPropertyEditors = function () {
        var self = this;
        return [
            propertyEditors.createTextArea('Suggestie tekst')
                .withGet(function () {
                    return self.data.tekst;
                })
                .withSet(function (value) {
                    self.data.tekst = value;
                })
                .withDataDecorator('tekst')
        ];
    };

    ShareOnFacebookDesign.prototype.afterSave = function () {
        this.$element.removeClass('inheritedTekst');
    };

    ShareOnFacebookDesign.prototype.createOperationRoute = 'addShareOnFacebookDrop';
    ShareOnFacebookDesign.prototype.updateOperationRoute = 'updateShareOnFacebookDrop';

    return ShareOnFacebookDesign;
});