﻿define([
    'jquery',
    'nico/drop',
    'nico/dispatcher'
], function ($, Drop, Dispatcher) {
    'use strict';

    var defaults = function () {
        return {
            tekst: ''
        }
    };

    function ShareOnTwitter(options, $element) {
        Drop.call(this, $element, defaults());

        var self = this;

        this.data = $.extend(this.data, options);

        this.$twitter = $('<a />')
            .addClass('button small twitter')
            .append($('<span />').addClass('icon icon-twitter'))
            .append($('<span />').text('  TWITTER'))
            .click(function (e) {
                self.handleTwitter();
                e.preventDefault();
            });

        this.$element
            .append(this.$tekst, this.$twitter);
    };

    Drop.extend(ShareOnTwitter, Drop);

    ShareOnTwitter.prototype.dispatcher = new Dispatcher();

    ShareOnTwitter.prototype.handleTwitter = function () {
        if (window.plugins && window.plugins.socialsharing) {
            window.plugins.socialsharing.shareViaTwitter(this.data.tekst);
        } else {

            var winHeight = screen.height;
            var winWidth = screen.width;
            var width = 550;
            var height = 420;
            var left = Math.round((winWidth / 2) - (width / 2));
            var top = 0;
            if (winHeight > height) {
                top = Math.round((winHeight / 2) - (height / 2));
            }
            var url = 'https://twitter.com/intent/tweet?text=' + this.data.tekst;
            if (this.data.hashTags)
                url += '&hashtags=' + this.data.hashTags;
            window.open(
                url,
                '_blank',
                'width=' + width + ',height=' + height + ',top=' + top + ',left=' + left);
        }

        return false;
    };

    ShareOnTwitter.prototype.preRender = function () {
        this.applyPosition();
    };

    return ShareOnTwitter;
});