﻿define([
    'jquery',
    'nico/drop',
    './shareOnTwitter',
    'nico/Designer/propertyEditors'
], function ($, Drop, ShareOnTwitter, propertyEditors) {
    'use strict';

    function ShareOnTwitterDesign(options, $element) {
        ShareOnTwitter.call(this, options, $element);
        if (this.data.tekstInherited)
            this.$element
                .addClass('inheritedTekst');
        this.initAnchorData(this.data);
        this.addClicksForEdit(this.getPropertyEditors());
    };

    Drop.extend(ShareOnTwitterDesign, ShareOnTwitter);

    ShareOnTwitterDesign.prototype.handleFacebook = $.noop;
    ShareOnTwitterDesign.prototype.handleTwitter = $.noop;

    ShareOnTwitterDesign.prototype.addSaveData = function (data) {
        data.tekst = this.data.tekst;
    };

    ShareOnTwitterDesign.prototype.getPropertyEditors = function () {
        var self = this;
        return [
            propertyEditors.createTextArea('Suggestie tekst')
                .withGet(function () {
                    return self.data.tekst;
                })
                .withSet(function (value) {
                    self.data.tekst = value;
                })
                .withDataDecorator('tekst'),
            propertyEditors.createTextArea('Hash Tags')
                .withGet(function () {
                    return self.data.hashTags;
                })
                .withSet(function (value) {
                    self.data.hashTags = value;
                })
                .withDataDecorator('hashTags')
        ];
    };

    ShareOnTwitterDesign.prototype.afterSave = function () {
        this.$element.removeClass('inheritedTekst');
    };

    ShareOnTwitterDesign.prototype.createOperationRoute = 'addShareOnTwitterDrop';
    ShareOnTwitterDesign.prototype.updateOperationRoute = 'updateShareOnTwitterDrop';

    return ShareOnTwitterDesign;
});