﻿define([
    'jquery',
    'nico/drop',
    './../VraagStelling/vraagStelling',
    'nouislider'
], function ($, Drop, VraagStelling, nouislider) {
    'use strict';

    var defaults = function() {
        return {
            fixedVariabeleType: true,
            variabele: {
                type: 'number'
            },
            leftLabel: '',
            rightLabel: '',
            steps: [0]
        };
    };

    function Slider(options, $element) {
        VraagStelling.call(this, $.extend(defaults(), options), $element);

        this.$leftLabel = $('<div />')
            .addClass('left')
            .text(this.data.leftLabel);

        this.$rightLabel = $('<div />')
            .addClass('right')
            .text(this.data.rightLabel);

        this.$labels = $('<div />')
            .addClass('slider-tags')
            .append(this.$leftLabel, this.$rightLabel);

        this.$slider = $('<div />');
        this.$sliderWrapper = $('<div />')
            .addClass('slider-wrap')
            .append(this.$slider);

        this.$element
            .append(this.$labels, this.$sliderWrapper);
    };

    Drop.extend(Slider, VraagStelling);

    Slider.prototype.preRender = function () {
        this.setupSlider();
        this.applyPosition();
    };

    Slider.prototype.setupSlider = function () {
        var indexOfInitialStep = this.getIndexOfInitialStep();

        var self = this;
        this.$slider
            .noUiSlider({
                start: indexOfInitialStep,
                step: 1,
                range: {
                    'min': 0,
                    'max': this.data.steps.length - 1
                }
            })
            .change(function () {
                self.updateAntwoord();
            });

        // note: a slider always has a value
        this.updateAntwoord();
    };

    Slider.prototype.updateAntwoord = function () {
        var value = this.getValueOfCurrentIndex();
        this.registreerAntwoord(value);
    };

    Slider.prototype.clearValue = function () {
        var index = this.getIndexOfInitialStep();
        this.$slider.val(index);
    };

    Slider.prototype.getValueOfCurrentIndex = function () {
        var index = parseInt(this.$slider.val());
        return this.data.steps[index];
    };

    Slider.prototype.getIndexOfInitialStep = function () {
        var waarde = this.getInitieelAntwoord() + '';
        if (waarde) {
            var index = this.data.steps.indexOf(waarde);
            if (index >= 0)
                return index;
        }
        return 0;
    };

    return Slider;
});