﻿define([
    'jquery',
    'nico/drop',
    './slider',
    './../VraagStelling/vraagStellingDesign',
    'nico/Designer/propertyEditors',
    './sliderStepsPropertyEditor'
], function ($, Drop, Slider, VraagStellingDesign, propertyEditors, SliderStepsPropertyEditor) {
    'use strict';

    function SliderDesign(options, $element) {
        Slider.call(this, options, $element);

        this.vraagStellingDesign = new VraagStellingDesign();

        if (this.data.tekstInherited)
            this.$element
                .addClass('inheritedTekst');

        this.initAnchorData(this.data);
        this.addClicksForEdit(this.getPropertyEditors());
    }

    Drop.extend(SliderDesign, Slider);

    SliderDesign.prototype.addSaveData = function (data) {
        this.vraagStellingDesign.decorateSaveData(data, this.data);
        data.leftLabel = this.$leftLabel.text();
        data.rightLabel = this.$rightLabel.text();
    };

    SliderDesign.prototype.afterSave = function () {
        this.$element
            .removeClass('inheritedTekst');
    };

    SliderDesign.prototype.createOperationRoute = 'addSliderDrop';
    SliderDesign.prototype.updateOperationRoute = 'updateSliderDrop';

    SliderDesign.prototype.getPropertyEditors = function () {
        var self = this;

        return this.vraagStellingDesign.decorateEditors(
            propertyEditors.createText('Default Waarde'),
            [
                propertyEditors.createText('Left label')
                .withGet(function() {
                    return self.$leftLabel.text();
                })
                .withSet(function(value) {
                    self.$leftLabel.text(value);
                })
                .withDataDecorator('leftLabel'),
                propertyEditors.createText('Right label')
                .withGet(function() {
                    return self.$rightLabel.text();
                })
                .withSet(function(value) {
                    self.$rightLabel.text(value);
                })
                .withDataDecorator('rightLabel'),
                new SliderStepsPropertyEditor()
                .withGet(function() {
                    return self.data.steps;
                })
                .withSet(function(value) {
                    self.data.steps = value;
                })
                .withDataDecorator('steps')
            ],
            self.data);
    };

    return SliderDesign;
});