﻿define([
    'jquery',
    'nico/drop',
    './switchSchermKnop',
    'nico/Designer/propertyEditors',
    'nico/Designer/buttonDesign'
], function ($, Drop, SwitchSchermKnop, propertyEditors, ButtonDesign) {
    'use strict';

    function SwitchSchermKnopDesign(options, $element) {
        SwitchSchermKnop.call(this, options, $element);

        this.buttonDesign = new ButtonDesign(this.data);

        if(this.data.tekstInherited)
            this.$element
                .addClass('inheritedTekst');

        this.initAnchorData(this.data);
        this.addClicksForEdit(this.getPropertyEditors());
    };

    Drop.extend(SwitchSchermKnopDesign, SwitchSchermKnop);

    SwitchSchermKnopDesign.prototype.handleClick = $.noop;

    SwitchSchermKnopDesign.prototype.getPropertyEditors = function () {
        var self = this;
        return this.buttonDesign.decorateEditors([

            propertyEditors.createText('Knop tekst')
                .withGet(function () {
                    return self.$tekst.text();
                })
                .withSet(function (value) {
                    self.$tekst.text(value);
                })
                .withDataDecorator('tekst')

        ]);
    };

    SwitchSchermKnopDesign.prototype.addSaveData = function (data) {
        this.buttonDesign.addSaveData(data);
        data.tekst = this.$tekst.html();
    };

    SwitchSchermKnopDesign.prototype.afterSave = function () {
        this.$element.removeClass('inheritedTekst');
    };

    SwitchSchermKnopDesign.prototype.createOperationRoute = 'addSwitchSchermKnop';
    SwitchSchermKnopDesign.prototype.updateOperationRoute = 'updateSwitchSchermKnop';

    return SwitchSchermKnopDesign;
});