﻿define([
    'jquery',
    'nico/drop',
    'nico/Designer/propertyEditors',
    './tailoredTekst'
], function ($, Drop, propertyEditors, TailoredTekst) {
    'use strict';

    function TailoredTekstDesign(options, $element) {
        TailoredTekst.call(this, options, $element);

        if (this.data.tekstInherited)
            this.$element
                .addClass('inheritedTekst');

        this.initAnchorData(this.data);
        this.addClicksForEdit(this.getPropertyEditors());
    };

    Drop.extend(TailoredTekstDesign, TailoredTekst);

    TailoredTekstDesign.prototype.getPropertyEditors = function () {
        var self = this;

        return [

            propertyEditors.createRichText('Tekst')
                .withGet(function () {
                    return self.$element.html();
                })
                .withSet(function (value) {
                    self.$element.html(value);
                })
                .withDataDecorator('tekst'),

            propertyEditors.createCutoff('Cutoff')
                .withGet(function () {
                    return self.data.cutoff;
                })
                .withSet(function (value) {
                    self.data.cutoff = value;
                })
                .withDataDecorator('cutoff')

        ];
    };

    TailoredTekstDesign.prototype.addSaveData = function (data) {
        data.tekst = this.$element.html();
        data.variabeleId = this.data.cutoff.variabeleId;
        data.lowerCutoff = this.data.cutoff.lowerCutoff;
        data.higherCutoff = this.data.cutoff.higherCutoff;
    };

    TailoredTekstDesign.prototype.afterSave = function () {
        this.$element
            .removeClass('inheritedTekst');
    };

    TailoredTekstDesign.prototype.createOperationRoute = "addTailoredTekstDrop";
    TailoredTekstDesign.prototype.updateOperationRoute = "updateTailoredTekstDrop";
    TailoredTekstDesign.prototype.deleteOperationRoute = "deleteTailoredTekstDrop";

    return TailoredTekstDesign;
});