﻿define([
    'jquery',
    'nico/drop',
    'nico/url'
], function ($, Drop, url) {
    'use strict';

    var defaults = function () {
        return {
            tekst: ''
        };
    };

    function Tekst(options, $element) {
        Drop.call(this, $element, defaults());

        this.data = $.extend(this.data, options);
        
        this.$element
            .html(this.data.tekst);

        this.$element.find('a').click(function (e) {
            e.preventDefault();

            var a = $(this);
            var href = a.attr('href');
            var target = a.attr('target');
            url.openUrl(href, target);
        });
    };

    Drop.extend(Tekst, Drop);

    Tekst.prototype.preRender = function () {
        this.applyPosition();
    };

    return Tekst;
});