﻿define([
    'jquery',
    'nico/drop',
    './tekst',
    'nico/Designer/propertyEditors'
], function ($, Drop, Tekst, propertyEditors) {
    'use strict';

    function TekstDesign(options, $element) {
        Tekst.call(this, options, $element);

        if (this.data.tekstInherited)
            this.$element
                .addClass('inheritedTekst');

        this.initAnchorData(this.data);
        this.addClicksForEdit(this.getPropertyEditors());
    };

    Drop.extend(TekstDesign, Tekst);

    TekstDesign.prototype.getPropertyEditors = function () {
        var self = this;

        return [

            propertyEditors.createRichText('Tekst')
                .withGet(function() {
                    return self.$element.html();
                })
                .withSet(function(value) {
                    self.$element.html(value);
                })
                .withDimensions(800, 560)
                .withDataDecorator('tekst'),

            propertyEditors.createTextArea('Conditie')
                .withGet(function () {
                    return self.data.conditie;
                })
                .withSet(function (value) {
                    self.data.conditie = value;
                })
                .onlyShowWhen(function () {
                    return self.data.conditional;
                })
                .withDataDecorator('conditie')

        ];
    };

    TekstDesign.prototype.addSaveData = function (data) {
        data.tekst = this.$element.html();
        data.conditie = this.data.conditie;
    };

    TekstDesign.prototype.afterSave = function () {
        this.$element
            .removeClass('inheritedTekst');
    };

    TekstDesign.prototype.createOperationRoute = 'addTekstDrop';
    TekstDesign.prototype.updateOperationRoute = 'updateTekstDrop';

    return TekstDesign;
});