﻿define([
    'jquery',
    'nico/drop',
    './tekstKort',
    'nico/Designer/propertyEditors'
], function ($, Drop, TekstKort, propertyEditors) {
    'use strict';

    function TekstKortDesign(options, $element) {
        TekstKort.call(this, options, $element);

        if (this.data.tekstInherited)
            this.$element
                .addClass('inheritedTekst');

        this.initAnchorData(this.data);
        this.addClicksForEdit(this.getPropertyEditors());
    };

    Drop.extend(TekstKortDesign, TekstKort);

    TekstKortDesign.prototype.getPropertyEditors = function () {
        var self = this;

        return [

            propertyEditors.createRichText('Tekst')
                .withGet(function() {
                    return self.$element.html();
                })
                .withSet(function(value) {
                    self.$element.html(value);
                })
                .withDimensions(640, 80)
                .withResizeButton(640, 560)
                .withDataDecorator('tekst'),

            propertyEditors.createTextArea('Conditie')
                .withGet(function () {
                    return self.data.conditie;
                })
                .withSet(function (value) {
                    self.data.conditie = value;
                })
                .onlyShowWhen(function() {
                    return self.data.conditional;
                })
                .withDataDecorator('conditie')

        ];
    };

    TekstKortDesign.prototype.addSaveData = function (data) {
        data.tekst = this.$element.html();
        data.conditie = this.data.conditie;
    };

    TekstKortDesign.prototype.afterSave = function () {
        this.$element
            .removeClass('inheritedTekst');
    };

    TekstKortDesign.prototype.createOperationRoute = 'addTekstDrop';
    TekstKortDesign.prototype.updateOperationRoute = 'updateTekstDrop';

    return TekstKortDesign;
});