﻿define([
    'jquery',
    'nico/drop',
    './tekstZonderOpmaak',
    'nico/Designer/propertyEditors'
], function ($, Drop, TekstZonderOpmaak, propertyEditors) {
    'use strict';

    function TekstZonderOpmaakDesign(options, $element) {
        TekstZonderOpmaak.call(this, options, $element);

        if (this.data.tekstInherited)
            this.$element
                .addClass('inheritedTekst');

        this.initAnchorData(this.data);
        this.addClicksForEdit(this.getPropertyEditors());
    };

    Drop.extend(TekstZonderOpmaakDesign, TekstZonderOpmaak);

    TekstZonderOpmaakDesign.prototype.getPropertyEditors = function () {
        var self = this;

        return [

            propertyEditors.createTextArea('Tekst')
                .withGet(function() {
                    return self.$element.html();
                })
                .withSet(function(value) {
                    self.$element.html(value);
                })
                .withDataDecorator('tekst')

        ];
    };

    TekstZonderOpmaakDesign.prototype.addSaveData = function (data) {
        data.tekst = this.$element.text();
        data.conditie = this.data.conditie;
    };

    TekstZonderOpmaakDesign.prototype.afterSave = function () {
        this.$element
            .removeClass('inheritedTekst');
    };

    TekstZonderOpmaakDesign.prototype.createOperationRoute = 'addTekstDrop';
    TekstZonderOpmaakDesign.prototype.updateOperationRoute = 'updateTekstDrop';

    return TekstZonderOpmaakDesign;
});