﻿define([
    'jquery',
    'nico/drop',
    './video',
    'nico/Designer/propertyEditors'
], function ($, Drop, Pager, propertyEditors) {
    'use strict';

    function VideoDesign(options, $element) {
        Pager.call(this, options, $element);
        this.addClicksForEdit(this.getPropertyEditors());
    };

    Drop.extend(VideoDesign, Pager);

    VideoDesign.prototype.getPropertyEditors = function () {
        var self = this;

        return [
            
            propertyEditors.createText('Embed code')
                .withGet(function () {
                    return self.data.embedCode;
                })
                .withSet(function (value) {
                    if (value !== self.data.embedCode) {
                        self.data.embedCode = value;
                        self.prepareVideo(value);
                    }
                })
                .withDataDecorator('embedCode')

        ];
    };

    return VideoDesign;
});