﻿define([
    'jquery',
    'nico/drop',
    'nico/eventing'
], function ($, Drop) {
    'use strict';

    var defaults = function() {
        return {
            tags: [],
            variabele: {
                naam: null,
                type: null,
                defaultWaarde: null
            },
            verplicht: false,
            toonVorigeWaarde: true,
            waarde: null
        };
    };

    function VraagStelling(options, $element) {

        Drop.call(this, $element, defaults());

        this.data = $.extend(this.data, options);

        this._registreerVraag();

        return this;
    };

    Drop.extend(VraagStelling, Drop);
    
    VraagStelling.prototype.getInitieelAntwoord = function () {
        var waarde = null;
        if (this.data.variabele.defaultWaarde != null && this.data.variabele.defaultWaarde != undefined)
            waarde = this.getDefaultwaarde();
        if (this.data.waarde != null && this.data.waarde != undefined)
            waarde = this.data.waarde;
        return waarde;
    };

    VraagStelling.prototype.getDefaultwaarde = function () {
       return this.data.variabele.defaultWaarde;
    };
    
    VraagStelling.prototype.registreerAntwoord = function (waarde) {
        if (!this.data.quizMaster)
            return;
        this.data.quizMaster
            .registreerAntwoord(this.data.variabele.naam, waarde);
    };

    VraagStelling.prototype._registreerVraag = function () {
        if (!this.data.quizMaster)
            return;
        this.data.quizMaster.registreerVraag(this.data.variabele.naam, this.data.verplicht, this.getInitieelAntwoord(), this);
    };
    
    VraagStelling.prototype.preRender = function () {
        this.applyPosition();
    };

    VraagStelling.prototype.createOperationRoute = "addDropWithVariabele";
    VraagStelling.prototype.updateOperationRoute = "updateDropWithVariabele";

    return VraagStelling;
});