﻿define([
    'jquery',
    'underscore'
], function ($, _) {

    var TemplateTraverser = function($template) {
        this.$template = $template;
        this.dropNodes = [];
    };

    TemplateTraverser.prototype.traverse = function() {
        this.lookForDropNodes(this.$template);
        return this.dropNodes;
    };

    TemplateTraverser.prototype.lookForDropNodes = function ($node) {
        if (this.isDropNode($node)) {
            this.dropNodes.push($node);
            return;
        }

        var self = this;
        _.each($node.children(), function(child) {
            self.lookForDropNodes($(child));
        });
    };

    TemplateTraverser.prototype.isDropNode = function ($node) {
        return $node.data('naam') && !$node.data('ignore');
    };

    return TemplateTraverser;
});