﻿// todo this file is shared between the web and mobile site
define([
    'jquery',
    'nico/dispatcher',
    'nico/modalWindow'
], function ($, Dispatcher, modalWindow) {

    function Company() {
        this.modal = modalWindow.getModal('register-company-code');
        this.$bedrijfsCode = this.modal.$window
            .find('#company-code')
            .change(function() {
                self.$msg.hide();
            });
        this.$msg = this.modal.$window
            .find('#company-msg');

        var self = this;
        this.$submit = this.modal.$window
            .find('#company-code-submit')
            .click(function () {
                self.submit();
            });

        this.$cancel = this.modal.$window
            .find('.cancel-registration')
            .click(function () {
                self.cancel();
            });
    };

    Company.prototype.dispatcher = new Dispatcher();

    Company.prototype.show = function (data) {
        this.data = data;
        this.modal.show();

        this.$msg.hide();
        this.$bedrijfsCode
            .val('')
            .focus();

        this.deferred = $.Deferred();
        return this.deferred.promise();
    };

    Company.prototype.cancel = function () {
        this.modal.close();
    };

    Company.prototype.submit = function () {
        this.$msg.hide();
        this.$msg.text('');

        var code = this.$bedrijfsCode.val();

        var self = this;
        this.dispatcher
            .post('/Home/ActivateAccount', {
                gebruikerId: self.data.gebruikerId,
                companyCode: code
            })
            .done(function (result) {
                self.deferred.resolve(self.data, result);
            })
            .fail(function(msg) {
                self.$msg.text(msg);
                self.$msg.show();
            });
    };

    return Company;
});