define([
    'jquery',
    'nico/Login/loginForm',
    './registration',
    './company',
    'nico/jquery.extensions.common'
], function ($, LoginForm, Registration, Company) {
    'use strict';

    var start = function () {
        if (navigator.connection.type === Connection.NONE) {
            window.location.href = 'offline.html';
            return;
        }

        var company = new Company();
        var login = new LoginForm($('#loginForm'), company);
        var registration = new Registration(company);

        $('#start-registration')
            .click(function () {
                registration
                    .start()
                    .done(function (data, result) {
                        login.clear();
                        login.submit(data.email, data.wachtwoord);
                    });
            });
    };

    return {
        start: start
    };

});