﻿// todo this file is shared between the web and mobile site
define([
    'jquery',
    'nico/url',
    './identification',
    './profile'
], function ($, url, Identification, Profile) {
    
    var Registration = function(company) {
        this.company = company;
        this.identification = new Identification();
        this.profile = new Profile();
    };

    Registration.prototype.start = function () {
        var self = this;
        this.identification
            .show()
            .then(function (data) {
                if (data.needsActivation)
                    return $.Deferred().resolve(data);
                return self.profile.show(data);
            })
            .then(function (data) {
                return self.company.show(data);
            })
            .then(function (data, result) {
                return self.deferred.resolve(data, result);
            });

        this.deferred = $.Deferred();
        return this.deferred.promise();
    };

    return Registration;
});