define([
    'jquery',
    'nico/observable'
],function($, observable) {
    'use strict';

    var JaNeeVraag = function(data) {
        observable.makeObservable(this);
        this.data = data;
        this.$element = $('<div />')
            .addClass('jaNeeVraag');
    };

    JaNeeVraag.prototype.render = function($target) {
        var self = this;

        var $vraag = $('<div />')
            .addClass('vraagstelling')
            .text(this.data.vraag);

        var $opties = $('<div />')
            .addClass('options')
            .append($('<div />')
                .addClass('button green big clickable')
                .text('Ja')
                .css('width', '5rem')
                .click(function() {
                    self.answer(true);
                }))
            .append($('<div />')
                .addClass('button green big clickable')
                .text('Nee')
                .css('width', '5rem')
                .click(function () {
                    self.answer(false);
                }));

        this.$element
            .append($vraag, $opties)
            .appendTo($target);

        this.informListeners('rendered');
    };

    JaNeeVraag.prototype.answer = function(answer) {
        this.informListeners('answered', answer);
    };

    JaNeeVraag.prototype.destroy = function () {
        this.$element.remove();
    };

    return JaNeeVraag;
});