define([
    'jquery',
    'nico/dispatcher',
    'nico/Panic/panicRuntime',
    'nico/userSettings',
    'nico/systeemBoodschappen'
], function ($, Dispatcher, PanicRuntime, userSettings, systeemBoodschappen) {
    'use strict';

    var start = function() {
        $('#closePanic')
            .click(function () {
                window.location.href = 'index.html';
            });

        var batch = [
            {
                route: '/Panic',
                data: {
                    gezondheidsDomeinId: userSettings.get().programma.id
                },
                done: function (result) {
                    new PanicRuntime().show(result);
                    $('#title').text(result.adviesNuTekst);
                }
            },
            {
                route: '/SysteemBoodschappen/Runtime/Load',
                done: function (result) {
                    systeemBoodschappen.set(result);
                }
            }
        ];

        new Dispatcher().postBatch(batch);
    };

    return {
        start: start
    };

});