define([
    'nico/dispatcher',
    'nico/userSettings'
],function(Dispatcher, userSettings) {
    'use strict';

    var PanicRuntime = function() {
        this.$vraag = $('#panic');
        this.serverIsWorking = false;
    };

    PanicRuntime.prototype.dispatcher = new Dispatcher();

    PanicRuntime.prototype.show = function(data) {
        var self = this;
        var moduleName = this.getModuleNameOfVraag(data.type);
        require([moduleName] , function(Vraag) {
            self.renderVraag(Vraag, data);
        });
    };

    PanicRuntime.prototype.getModuleNameOfVraag = function(typeName) {
        var module = typeName.charAt(0).toLowerCase() + typeName.slice(1);
        return 'Nico/Panic/Steps/' + module;
    };

    PanicRuntime.prototype.renderVraag = function(Constructor, data) {
        var self = this;
        var vraag = new Constructor(data);

        vraag.addListener('answered', function (answer) {
            // note: make sure we only have 1 request running at a time (on some mobile devices
            // multiple requests are sent. Not sure why)
            if(self.serverIsWorking)
                return;

            self.serverIsWorking = true;
            self.dispatcher
                .post('next', {
                    gezondheidsDomeinId: userSettings.get().programma.id,
                    stapId: data.stapId,
                    antwoord: answer
                })
                .done(function (data) {
                    vraag.removeListener('answered', self);
                    vraag.destroy();
                    self.show(data);
                })
                .always(function () {
                    self.serverIsWorking = false;
                });
        }, this);

        vraag.render(this.$vraag);
    };

    return PanicRuntime;
});