define([
    'jquery',
    'underscore',
    'nico/dispatcher',
    'nico/userSettings'
],function($, _, Dispatcher, userSettings) {
    'use strict';

    var ProgrammaSelectie = function($element) {
        this.$element = $element;
    };

    ProgrammaSelectie.prototype.dispatcher = new Dispatcher();

    ProgrammaSelectie.prototype.open = function() {
        var self = this;
        this.dispatcher
            .post('/Gebruiker/Programmas')
            .done(function (data) {
                self.showProgrammas(data);
            });
    };

    ProgrammaSelectie.prototype.showProgrammas = function(programmas) {
        var self = this;
        var $programmas = _.map(programmas, function(programma) {
            return $('<li />')
                .text(programma.titel)
                .addClass('programma clickable ' + programma.kleur)
                .click(function () {
                    self.selecteerProgramma(programma);
                });
        });
        this.$element
            .append($('<div />')
            .append($programmas));
    };

    ProgrammaSelectie.prototype.selecteerProgramma = function (programma) {
        this.dispatcher
            .post('changeActiefProgramma', {
                programmaId: programma.id,
                programmaTitel: programma.titel
            })
            .done(function (data) {
                userSettings.update({
                    programma: programma
                });
                window.location.href = 'index.html';
            });
    };

    return ProgrammaSelectie;
});