define([
    'jquery',
    'underscore',
    'nico/dispatcher',
    'nico/textReplacer',
    'nico/localStorage'
], function ($, _, Dispatcher, textReplacer, localStorage) {
    'use strict';

    var TaalSelectie = function($element) {
        this.$element = $element;
    };

    TaalSelectie.prototype.dispatcher = new Dispatcher();

    TaalSelectie.prototype.open = function() {
        var self = this;
        this.dispatcher
            .post('/Gebruiker/Talen')
            .done(function (data) {
                textReplacer.apply(data.teksten);
                var $taal = $('#taal');
                var $instellen = $('#instellen');
                var $options = _.map(data.talen, function (taal) {
                    return $('<option>', { text: taal.runtimeNaam, value: taal.code });
                });
                $taal
                    .append($options)
                    .val(data.huidigeTaal)
                    .change(function () {
                    });

                $instellen
                    .attr('disabled', 'disabled')
                    .click(function () {
                        self.dispatcher
                            .post('wijzigTaal', {
                                taalCode: $taal.val()
                            })
                            .done(function () {
                                localStorage.set('nicoCulture', $taal.val());
                                window.location.href = 'index.html';
                            });
                    });
            });
    };

    return TaalSelectie;
});