﻿// todo this file is shared between the web and mobile site
define(function () {
    'use strict';

    var BoolRewrite = function (data) {
        this.data = data;
    };

    BoolRewrite.prototype.getBoolFromValue = function (value) {
        if (this.variabeleIsString())
            throw new Error('Rewriting a bool to a string is not yet supported');

        if (this.variabeleIsBool())
            return value === true;
        if (value === null)
            return false;
        if (this.data.boolRewrite['true'] === value)
            return true;
        if (this.data.boolRewrite['false'] === value)
            return false;

       // throw new Error('Could not deduce a boolean value from the value "' + value + '".');
    };

    BoolRewrite.prototype.getValueFromBool = function (booleanValue) {
        if (this.variabeleIsString())
            throw new Error('Rewriting a bool to a string is not yet supported');

        if (this.variabeleIsBool())
            return booleanValue;

        var rewriteProp = booleanValue ? 'true' : 'false';
        return this.data.boolRewrite[rewriteProp];
    };

    BoolRewrite.prototype.variabeleIsBool = function () {
        return this.data.variabele.type === 'bool';
    };

    BoolRewrite.prototype.variabeleIsString = function () {
        return this.data.variabele.type === 'string';
    };

    return BoolRewrite;
});