define([
    'module',
    'nico/tokenMaster',
    'nico/jquery.extensions.common' // todo -> load these some other ways (get rid of the prefetching step in the webhost?
], function (module, tokenMaster) {
    'use strict';

    window.onerror = function (message, url, lineNumber) {
        navigator.notification.alert(message, $.noop, 'An error occured', 'OK');
    };

    var start = function (config) {
        if (navigator.connection.type === Connection.NONE) {
            window.location.href = 'offline.html';
            return;
        }

        if(!endsWith(window.location.pathname, 'login.html')) {
            if (shouldForceLogin()) {
                window.location.href = 'login.html';
                return;
            }
        }

        require([config.entryModule, 'nico/userSettings'], function (entryModule, userSettings) {
            var programma = userSettings.get().programma;
            var $body = $('body');

            if (programma)
                $body.addClass(programma.kleur);
            $body.removeClass('hidden');

            entryModule.start();
        });
    };

    var shouldForceLogin = function() {
        return !tokenMaster.hasToken();
    };

    function endsWith(string, searchTerm) {
        return string.indexOf(searchTerm, string.length - searchTerm.length) !== -1;
    }

    return {
        start: start
    };
});