﻿// todo this file is shared between the web and mobile site
define([
    'jquery',
    'jquery.blockUI'
], function ($) {
    'use strict';

    function BusyIndicator() {
        this.$spinner = $('<div />')
            .addClass('modal-window spinner')
            .append($('<div />')
                .addClass('indicator'));

        this.showCount = 0;

        $.blockUI.defaults.fadeOut = 150;
        $.blockUI.defaults.fadeIn = 750;
    };

    BusyIndicator.prototype.show = function () {
        this.showCount++;

        if (this.showCount === 1)
            this.blockAndWaitForSpinner(0);
    };

    BusyIndicator.prototype.hide = function () {
        this.showCount--;

        if (this.showCount < 1) {
            this.showCount = 0;

            $.unblockUI();

            if (this.timeout) {
                clearTimeout(this.timeout);
                this.timeout = null;
            }
        }
    };

    BusyIndicator.prototype.forceHide = function () {
        var original = Number(self.showCount);
        this.showCount = 0;
        this.hide();
        return original;
    };

    BusyIndicator.prototype.showWithCount = function (count) {
        this.showCount = count;
        this.blockAndWaitForSpinner();
    };

    BusyIndicator.prototype.blockAndWaitForSpinner = function () {
        $('body').block({
            baseZ: 99999,
            showOverlay: false,
            message: ''
        });

        var self = this;
        this.timeout = _.defer(function () {
            if (self.showCount > 0) {
                $.blockUI({
                    baseZ: 99999,
                    showOverlay: false,
                    message: self.$spinner,
                    css: {
                        border: 'none'
                    }
                });
            }
        });
    };

    return new BusyIndicator();
});