define(function(module) {
    'use strict';

    var LocalStorage = function() {
    };

    LocalStorage.prototype.has = function(key) {
        return this.get(key) != null;
    };

    LocalStorage.prototype.set = function(key, value) {
        localStorage.setItem(key, value);
    };

    LocalStorage.prototype.setObject = function(key, object) {
        localStorage.setItem(key, JSON.stringify(object));
    };

    LocalStorage.prototype.get = function(key) {
        return localStorage.getItem(key);
    };

    LocalStorage.prototype.getObject = function(key) {
        var value = localStorage.getItem(key);
        if (!value)
            return null;
        return JSON.parse(value);
    };

    LocalStorage.prototype.remove = function(key) {
        localStorage.removeItem(key);
    };

    LocalStorage.prototype.removeAllData = function() {
        return localStorage.clear();
    };

    return new LocalStorage();
});