﻿// todo this file is shared between the web and mobile site
define([
    'nico/observable'
], function (observable) {
    'use strict';

    var QuizMaster = function() {
        observable.makeObservable(this);
        this.vragen = [];
    };

    // todo: solve this in the publishers
    QuizMaster.prototype.checkForNumber = function (waarde) {
        if (waarde instanceof Number) 
            return waarde.valueOf();
        else
            return waarde;
    };

    QuizMaster.prototype.registreerVraag = function (variabeleNaam, verplicht, huidigeWaarde, drop) {
        var vraag = {
            'variabeleNaam': variabeleNaam,
            'verplicht': verplicht,
            'huidigeWaarde': this.checkForNumber(huidigeWaarde)
        };
        this.vragen.push(vraag);
    };

    QuizMaster.prototype.registreerAntwoord = function (variabeleNaam, antwoord) {
        var vraag = _.find(this.vragen, function (v) { return v.variabeleNaam == variabeleNaam; });
        vraag.huidigeWaarde = this.checkForNumber(antwoord);
        this.antwoordGeregistreerd();
    };

    QuizMaster.prototype.antwoordGeregistreerd = function() {
        
    };

    QuizMaster.prototype.getAntwoorden = function () {
        var antwoorden = {};
        _.each(this.vragen, function (v) {
            antwoorden[v.variabeleNaam] = v.huidigeWaarde;
        });
        return antwoorden;
    };

    QuizMaster.prototype.hasAntwoorden = function () {
        return this.vragen.length > 0;
    };

    QuizMaster.prototype.allesIngevuld = function () {
        var onvolledig = _.find(this.vragen, function (antwoord) {
            return antwoord.verplicht && (antwoord.huidigeWaarde === null || antwoord.huidigeWaarde === '') && !antwoord.conditional;
        });
        return !onvolledig;
    };

    return QuizMaster;
});