// todo can we share this file between the web and mobile site?
define([
    'module'
],function(module) {
    'use strict';

    var config = module.config();
    
    var getWebUrl = function (path) {
        if (path)
            return config.webHost + path;
        return config.webHost;
    };

    return {
        getFullUrl: function(relativeUrl) {
            var rootUrl = module.config().serviceUrl;
            return rootUrl + relativeUrl;
        },
        toUploadUrl: function (filename) {
            var filesUrl = module.config().filesUrl;
            return filesUrl + 'Data/Drops/' + filename;
        },
        redirect: function(path) {
            var url = getWebUrl(path);
            navigator.app.loadUrl(url, { openExternal: true });
        },
        openUrl: function (url, target) {
            navigator.app.loadUrl(url, { openExternal: true });
        },
        getWebUrl: getWebUrl
    };
});
