define([
    'nico/localStorage'
],function(localStorage) {
    'use strict';

    var userSettingsKey = 'userSettings';

    var UserSettings = function() {
        this.settings = localStorage.getObject(userSettingsKey) || {};
    };

    UserSettings.prototype.get = function() {
        return this.settings;
    };

    UserSettings.prototype.delete = function() {
        this.settings = {};
        localStorage.setObject(userSettingsKey, this.settings);
    };

    UserSettings.prototype.update = function(update) {
        for (var attr in update)
            this.settings[attr] = update[attr];
        localStorage.setObject(userSettingsKey, this.settings);
    };

    return new UserSettings();
});
