﻿// todo this file is shared between the web and mobile site
define([
    'widgets/templates',
    'underscore'
], function (templates, _) {

    var TemplateProvider = function() {
    };

    TemplateProvider.prototype.listAvailableTemplates = function () {
        var groups = _.chain(_.keys(templates))
            .filter(function(name) {
                return templates[name].group;
            })
            .sortBy(function (name) {
                return name;
            })
            .map(function (name) {
                return {
                    name: name,
                    group: templates[name].group
                };
            })
            .groupBy('group')
            .value();

        _.each(groups, function(val, key) {
            groups[key] = _.object(_.map(val, function(x) {
                return [x.name, x.name];
            }));
        });

        return groups;
    };

    TemplateProvider.prototype.createInstanceOfTemplate = function (templateName) {
        return $(templates[templateName].create());
    };

    return new TemplateProvider();
});